function iLI_Analysis(DataPath,Output,GroupName,SubIDPath)
% clear;clc;


%%% Parameters Setting
% DataPath='/autofs/eris/indi/Xpeng/Stroke/Pons/Lateralization/Resutls/iLI_ROIs_MeanSignal_and_CorrMat';
% Output='/autofs/eris/indi/Xpeng/Stroke/Pons/Lateralization/Resutls/Group_iLI_Regions';
mkdir([Output '/Group_iLI_Analysis']);
% SubIDs=importdata('/autofs/space/bidlin3_002/users/GSP_100subs/DataProcessed/list_GSP100.txt');
fileID = fopen(SubIDPath);
SubIDs=textscan(fileID,'%s');
SubIDs=SubIDs{1};

load('MedialWall_FS3.mat');
load('iLI_CB_FSnonlinear2mm_ROIr8mm.mat');
load('VolSpaceHDR.mat');
% GroupName='GSP100';
FC_Thres=0.1;
CECE_NumMostLat=100;
CBCB_NumMostLat=100;
CECB_NumMostLat=250;

%%% iLI Computation
for sub_ind=1:length(SubIDs)
    sub_ind
    sub_name=num2str(SubIDs{sub_ind})

    %%% CECE iLI
    load([DataPath '/' sub_name '/CECE_ROI_CorrMat.mat']);
    
    CECE_ROI_CorrMat.LH_LH(isnan(CECE_ROI_CorrMat.LH_LH))=0;
    CECE_ROI_CorrMat.LH_RH(isnan(CECE_ROI_CorrMat.LH_RH))=0;
    CECE_ROI_CorrMat.RH_LH(isnan(CECE_ROI_CorrMat.RH_LH))=0;
    CECE_ROI_CorrMat.RH_RH(isnan(CECE_ROI_CorrMat.RH_RH))=0;
    
    CECE_ROI_CorrMat.LH_LH=atanh(CECE_ROI_CorrMat.LH_LH);
    CECE_ROI_CorrMat.LH_RH=atanh(CECE_ROI_CorrMat.LH_RH);
    CECE_ROI_CorrMat.RH_LH=atanh(CECE_ROI_CorrMat.RH_LH);
    CECE_ROI_CorrMat.RH_RH=atanh(CECE_ROI_CorrMat.RH_RH);
    
    CECE_ROI_CorrMat.LH_LH(MedialWall_FS3,:)=0;
    CECE_ROI_CorrMat.LH_LH(:,MedialWall_FS3)=0;
    CECE_ROI_CorrMat.LH_RH(MedialWall_FS3,:)=0;
    CECE_ROI_CorrMat.LH_RH(:,MedialWall_FS3)=0;
    CECE_ROI_CorrMat.RH_LH(MedialWall_FS3,:)=0;
    CECE_ROI_CorrMat.RH_LH(:,MedialWall_FS3)=0;
    CECE_ROI_CorrMat.RH_RH(MedialWall_FS3,:)=0;
    CECE_ROI_CorrMat.RH_RH(:,MedialWall_FS3)=0;
    
    CECE_ROI_CorrMat.LH_LH(CECE_ROI_CorrMat.LH_LH<FC_Thres)=0;
    CECE_ROI_CorrMat.LH_RH(CECE_ROI_CorrMat.LH_RH<FC_Thres)=0;
    CECE_ROI_CorrMat.RH_LH(CECE_ROI_CorrMat.RH_LH<FC_Thres)=0;
    CECE_ROI_CorrMat.RH_RH(CECE_ROI_CorrMat.RH_RH<FC_Thres)=0;
    
    CECE_iLI_Big(sub_ind,:,:)=(CECE_ROI_CorrMat.LH_LH+CECE_ROI_CorrMat.LH_RH-CECE_ROI_CorrMat.RH_LH-CECE_ROI_CorrMat.RH_RH)./(abs(CECE_ROI_CorrMat.LH_LH)+abs(CECE_ROI_CorrMat.LH_RH)+abs(CECE_ROI_CorrMat.RH_LH)+abs(CECE_ROI_CorrMat.RH_RH));
    clear CECE_ROI_CorrMat
    
    %%% CBCB iLI
    load([DataPath '/' sub_name '/CBCB_ROI_CorrMat.mat']);
    
    CBCB_ROI_CorrMat.LH_LH(isnan(CBCB_ROI_CorrMat.LH_LH))=0;
    CBCB_ROI_CorrMat.LH_RH(isnan(CBCB_ROI_CorrMat.LH_RH))=0;
    CBCB_ROI_CorrMat.RH_LH(isnan(CBCB_ROI_CorrMat.RH_LH))=0;
    CBCB_ROI_CorrMat.RH_RH(isnan(CBCB_ROI_CorrMat.RH_RH))=0;
    
    CBCB_ROI_CorrMat.LH_LH=atanh(CBCB_ROI_CorrMat.LH_LH);
    CBCB_ROI_CorrMat.LH_RH=atanh(CBCB_ROI_CorrMat.LH_RH);
    CBCB_ROI_CorrMat.RH_LH=atanh(CBCB_ROI_CorrMat.RH_LH);
    CBCB_ROI_CorrMat.RH_RH=atanh(CBCB_ROI_CorrMat.RH_RH);
    
    CBCB_ROI_CorrMat.LH_LH(CBCB_ROI_CorrMat.LH_LH<FC_Thres)=0;
    CBCB_ROI_CorrMat.LH_RH(CBCB_ROI_CorrMat.LH_RH<FC_Thres)=0;
    CBCB_ROI_CorrMat.RH_LH(CBCB_ROI_CorrMat.RH_LH<FC_Thres)=0;
    CBCB_ROI_CorrMat.RH_RH(CBCB_ROI_CorrMat.RH_RH<FC_Thres)=0;
    
    CBCB_iLI_Big(sub_ind,:,:)=(CBCB_ROI_CorrMat.LH_LH-CBCB_ROI_CorrMat.RH_RH)./(abs(CBCB_ROI_CorrMat.LH_LH)+abs(CBCB_ROI_CorrMat.RH_RH));
    clear CBCB_ROI_CorrMat
    
    %%% CECB iLI
    load([DataPath '/' sub_name '/CECB_ROI_CorrMat.mat']);
    
    CECB_ROI_CorrMat.LH_RH(isnan(CECB_ROI_CorrMat.LH_RH))=0;
    CECB_ROI_CorrMat.RH_LH(isnan(CECB_ROI_CorrMat.RH_LH))=0;
    
    CECB_ROI_CorrMat.LH_RH=atanh(CECB_ROI_CorrMat.LH_RH);
    CECB_ROI_CorrMat.RH_LH=atanh(CECB_ROI_CorrMat.RH_LH);
    
    CECB_ROI_CorrMat.LH_RH(CECB_ROI_CorrMat.LH_RH<FC_Thres)=0;
    CECB_ROI_CorrMat.RH_LH(CECB_ROI_CorrMat.RH_LH<FC_Thres)=0;
    
    CECB_iLI_Big(sub_ind,:,:)=(CECB_ROI_CorrMat.LH_RH-CECB_ROI_CorrMat.RH_LH)./(abs(CECB_ROI_CorrMat.LH_RH)+abs(CECB_ROI_CorrMat.RH_LH));
    clear CECB_ROI_CorrMat
end

%%% CECE iLI
CECE_iLI_Big(isnan(CECE_iLI_Big))=0;
CECE_iLI_Mean=squeeze(mean(CECE_iLI_Big,1));
FileName=[Output '/Group_iLI_Analysis/CECE_iLI_' GroupName '.mat'];
save(FileName,'CECE_iLI_Mean');

iLI_Sort=sort(reshape(CECE_iLI_Mean,prod(size(CECE_iLI_Mean)),1));
LowThres=iLI_Sort(CECE_NumMostLat);
HighThres=iLI_Sort(length(iLI_Sort)-CECE_NumMostLat+1);

[LFTLink(:,1),LFTLink(:,2)]=find(CECE_iLI_Mean>=HighThres);
[RHTLink(:,1),RHTLink(:,2)]=find(CECE_iLI_Mean<=LowThres);

% Report Generate
CECE_iLI_LFT=mean(CECE_iLI_Big(:,find(CECE_iLI_Mean>=HighThres)))';
CECE_iLI_RHT=mean(CECE_iLI_Big(:,find(CECE_iLI_Mean<=LowThres)))';
fid=fopen([Output,'/Group_iLI_Analysis/CECE_iLI_Report_' GroupName '.txt'], 'wt');
fprintf(fid, '%s\t%s\t%s\n', 'SubIDs', 'CECE_iLI_LFT', 'CECE_iLI_RHT');
for sub_ind=1:length(SubIDs)
    fprintf(fid, '%s\t%6.4f\t%6.4f\n', SubIDs{sub_ind}, CECE_iLI_LFT(sub_ind), CECE_iLI_RHT(sub_ind));
end

LeftLatRegion=zeros(size(CECE_iLI_Mean,1),1);
RightLatRegion=zeros(size(CECE_iLI_Mean,1),1);

LeftLatRegion(unique(LFTLink))=1;
RightLatRegion(unique(RHTLink))=1;

FileName=[Output '/Group_iLI_Analysis/CECE_LeftLatRegions_FS3_' GroupName '.mgh'];
save_mgh(LeftLatRegion,FileName,eye(4));
FileName=[Output '/Group_iLI_Analysis/CECE_RightLatRegions_FS3_' GroupName '.mgh'];
save_mgh(RightLatRegion,FileName,eye(4));
clear CECE_iLI_Big CECE_iLI_Mean iLI_Sort LowThres HighThres LFTLink RHTLink LeftLatRegion RightLatRegion;

%%% CBCB iLI
CBCB_iLI_Big(isnan(CBCB_iLI_Big))=0;
CBCB_iLI_Mean=squeeze(mean(CBCB_iLI_Big,1));
FileName=[Output '/Group_iLI_Analysis/CBCB_iLI_' GroupName '.mat'];
save(FileName,'CBCB_iLI_Mean');

iLI_Sort=sort(reshape(CBCB_iLI_Mean,prod(size(CBCB_iLI_Mean)),1));
LowThres=iLI_Sort(CBCB_NumMostLat);
HighThres=iLI_Sort(length(iLI_Sort)-CBCB_NumMostLat+1);

[LFTLink(:,1),LFTLink(:,2)]=find(CBCB_iLI_Mean>=HighThres);
[RHTLink(:,1),RHTLink(:,2)]=find(CBCB_iLI_Mean<=LowThres);

% Report Generate
CBCB_iLI_LFT=mean(CBCB_iLI_Big(:,find(CBCB_iLI_Mean>=HighThres)))';
CBCB_iLI_RHT=mean(CBCB_iLI_Big(:,find(CBCB_iLI_Mean<=LowThres)))';
fid=fopen([Output,'/Group_iLI_Analysis/CBCB_iLI_Report_' GroupName '.txt'], 'wt');
fprintf(fid, '%s\t%s\t%s\n', 'SubIDs', 'CBCB_iLI_LFT', 'CBCB_iLI_RHT');
for sub_ind=1:length(SubIDs)
    fprintf(fid, '%s\t%6.4f\t%6.4f\n', SubIDs{sub_ind}, CBCB_iLI_LFT(sub_ind), CBCB_iLI_RHT(sub_ind));
end

% Mat2Vol
LeftVerts=iLI_CB_FSnonlinear2mm_ROIr8mm.Left_ROIs(unique(LFTLink));
hdr_tmp=VolSpaceHDR;
vol_tmp=hdr_tmp.vol;
vol_tmp=reshape(vol_tmp,prod(size(vol_tmp)),1);
for L_ind=1:length(LeftVerts)
    vol_tmp(LeftVerts{L_ind})=1;
end
vol_tmp=reshape(vol_tmp,size(hdr_tmp.vol));
hdr_tmp.vol=vol_tmp;
FileName=[Output '/Group_iLI_Analysis/CBCB_LeftLatRegions_FS2mm_' GroupName '.nii.gz'];
MRIwrite(hdr_tmp,FileName);
clear *_tmp;

RightVerts=iLI_CB_FSnonlinear2mm_ROIr8mm.Right_ROIs(unique(RHTLink));
hdr_tmp=VolSpaceHDR;
vol_tmp=hdr_tmp.vol;
vol_tmp=reshape(vol_tmp,prod(size(vol_tmp)),1);
for R_ind=1:length(RightVerts)
    vol_tmp(RightVerts{R_ind})=1;
end
vol_tmp=reshape(vol_tmp,size(hdr_tmp.vol));
hdr_tmp.vol=vol_tmp;
FileName=[Output '/Group_iLI_Analysis/CBCB_RightLatRegions_FS2mm_' GroupName '.nii.gz'];
MRIwrite(hdr_tmp,FileName);
clear *_tmp;
clear CBCB_iLI_Big CBCB_iLI_Mean iLI_Sort LowThres HighThres LFTLink RHTLink LeftVerts RightVerts;

%%% CECB iLI
CECB_iLI_Big(isnan(CECB_iLI_Big))=0;
CECB_iLI_Mean=squeeze(mean(CECB_iLI_Big,1));
FileName=[Output '/Group_iLI_Analysis/CECB_iLI_' GroupName '.mat'];
save(FileName,'CECB_iLI_Mean');

iLI_Sort=sort(reshape(CECB_iLI_Mean,prod(size(CECB_iLI_Mean)),1));
LowThres=iLI_Sort(CECB_NumMostLat);
HighThres=iLI_Sort(length(iLI_Sort)-CECB_NumMostLat+1);

[LFTLink(:,1),LFTLink(:,2)]=find(CECB_iLI_Mean>=HighThres);
[RHTLink(:,1),RHTLink(:,2)]=find(CECB_iLI_Mean<=LowThres);

% Report Generate
CECB_iLI_LFT=mean(CECB_iLI_Big(:,find(CECB_iLI_Mean>=HighThres)))';
CECB_iLI_RHT=mean(CECB_iLI_Big(:,find(CECB_iLI_Mean<=LowThres)))';
fid=fopen([Output,'/Group_iLI_Analysis/CECB_iLI_Report_' GroupName '.txt'], 'wt');
fprintf(fid, '%s\t%s\t%s\n', 'SubIDs', 'CECB_iLI_LFT', 'CECB_iLI_RHT');
for sub_ind=1:length(SubIDs)
    fprintf(fid, '%s\t%6.4f\t%6.4f\n', SubIDs{sub_ind}, CECB_iLI_LFT(sub_ind), CECB_iLI_RHT(sub_ind));
end

LeftLatRegion=zeros(size(CECB_iLI_Mean,1),1);
RightLatRegion=zeros(size(CECB_iLI_Mean,1),1);

LeftLatRegion(unique(LFTLink(:,1)))=1;
RightLatRegion(unique(RHTLink(:,1)))=1;

FileName=[Output '/Group_iLI_Analysis/CECB_LeftLatRegions_FS3_' GroupName '.mgh'];
save_mgh(LeftLatRegion,FileName,eye(4));
FileName=[Output '/Group_iLI_Analysis/CECB_RightLatRegions_FS3_' GroupName '.mgh'];
save_mgh(RightLatRegion,FileName,eye(4));
clear CECB_iLI_Big CECB_iLI_Mean iLI_Sort LowThres HighThres LeftLatRegion RightLatRegion;

% Mat2Vol (*Note: Left CE Lat region display on right CB seeds)
RightVerts=iLI_CB_FSnonlinear2mm_ROIr8mm.Right_ROIs(unique(LFTLink(:,2)));
hdr_tmp=VolSpaceHDR;
vol_tmp=hdr_tmp.vol;
vol_tmp=reshape(vol_tmp,prod(size(vol_tmp)),1);
for L_ind=1:length(RightVerts)
    vol_tmp(RightVerts{L_ind})=1;
end
vol_tmp=reshape(vol_tmp,size(hdr_tmp.vol));
hdr_tmp.vol=vol_tmp;
FileName=[Output '/Group_iLI_Analysis/CECB_LeftLatRegions_FS2mm_' GroupName '.nii.gz'];
MRIwrite(hdr_tmp,FileName);
clear *_tmp;

LeftVerts=iLI_CB_FSnonlinear2mm_ROIr8mm.Left_ROIs(unique(RHTLink(:,2)));
hdr_tmp=VolSpaceHDR;
vol_tmp=hdr_tmp.vol;
vol_tmp=reshape(vol_tmp,prod(size(vol_tmp)),1);
for R_ind=1:length(LeftVerts)
    vol_tmp(LeftVerts{R_ind})=1;
end
vol_tmp=reshape(vol_tmp,size(hdr_tmp.vol));
hdr_tmp.vol=vol_tmp;
FileName=[Output '/Group_iLI_Analysis/CECB_RightLatRegions_FS2mm_' GroupName '.nii.gz'];
MRIwrite(hdr_tmp,FileName);
clear *_tmp;
clear LFTLink RHTLink LeftVerts RightVerts;


